; Generic Memory Patch Loader By -/- Z-N0TE -\- SiAC '93
; -====================================================-

SIZE    EQU     0200h
FUNC    EQU     000Dh
INTNUM  EQU     10h

START:  MOV     SP,SIZE         ; Dunno but if left normal program crashes
        MOV     BX,SP           ; Make BX = BP
        ADD     BX,0Fh          ; Add 16
        MOV     CL,4            ; ...
        SHR     BX,CL           ; Divide BX by 16
        MOV     AH,4AH          ; Memory setup
        INT     21H             ; Do it
                
        MOV     AH,35h          ; Get INT info
        MOV     AL,INTNUM       ; INT Number we patched
        INT     21H             ; Do it
                                
        MOV     W [OLDINT],BX   ; Stash INT info
        MOV     W [OLDINT]+2,ES ; Stash INT info
        MOV     DX,OFFSET NEWINT; Setup new INT
        MOV     AH,25h          ; Set INT
        MOV     AL,INTNUM       ; INT Number we patched
        INT     21H             ; Do it

        PUSH    CS              ; Set ES back to normal
        POP     ES              ; ...
        MOV     HOLD_1,CS       ; Setup parameters
        MOV     HOLD_2,CS       ; Setup parameters
        MOV     HOLD_3,CS       ; Setup parameters
        MOV     DX,OFFSET PROG  ; Offset of program name
        MOV     BX,OFFSET PARAMS; Offset of parameters
        MOV     AX,4B00H        ; Run program
        INT     21H             ; Do it

        PUSH    CS              ; Set DS to CS so text will show
        POP     DS              ; ...

        MOV     AH,09h          ; Print Author
        MOV     DX,OFFSET TEXT  ; ...
        INT     21h             ; Do it

        MOV     AH,4Ch          ; Back to DOS
        INT     21h             ; ...

TEXT:   DB 'L0ADER BY Z-N0TE$'  ; Tell em who cracked it

PROG:   DB      'JWWS.EXE'      ; Name of program
PARAMS: DB      0
        DB      00H, 80H, 00H
HOLD_1  DW      0               ; segment storage
        DB      5CH, 00H
HOLD_2  DW      0               ; segment storage
        DB      6CH, 00H
HOLD_3  DW      0               ; segment storage

NEWINT: STI                     ; Enable interrupts
        PUSH    AX              ; Stash AX
        PUSH    DS              ; Stash DS
        PUSH    BP              ; Stash BP
                
        CMP     AX,FUNC         ; Is it right function ?
        JNE     EXIT            ; Nope EXIT

        MOV     BP,SP           ; Move SP into BP
        MOV     AX,SS:[BP+8]    ; Get actual code segment from stack
        SUB     AX,094Eh        ; Code we want is 094E bellow this bit
        MOV     DS,AX           ; Set it to our Data segment

        CMP     W [09EFh],0675h ; Is word at 09EFh = 75-06 (Reversed word) ?
        JNE     EXIT            ; If not EXIT

        MOV     W [09EFh],9090h ; Patch Doc Check in memory

        LDS     DX,DWORD PTR CS:[OLDINT] ; Oldint
        MOV     AH,25h          ; Restore INT
        MOV     AL,INTNUM       ; INT Number we patched
        INT     21H             ; Do it
        
EXIT:   POP     BP              ; Restore BP
        POP     DS              ; Restore DS
        POP     AX              ; Restore AX

        DB      0EA             ; JMP to REAL INT
OLDINT: DW      0000            ; Old INT segment and offset
        DW      0000            ; Old INT segment and offset
